@using Entities
@using Business
@using DataAccess

@inject IDbContextFactory<inventory_context> ContextFactory
@inject NavigationManager navManager

@if (DataLoading)
{
    <h4>@loading_message</h4>
}

<div>
    <table class="table table-hover table-bordered">
        <thead>
            <tr>
                <th>Warehouse ID</th>
                <th>Warehouse Name</th>
                <th>Warehouse Address</th>
                <th>Actions</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var warehouse in warehouses)
            {
                <tr>
                    <td>@warehouse.WarehouseId</td>
                    <td>@warehouse.WarehouseName</td>
                    <td>@warehouse.WarehouseAddress</td>
                    <td>
                        <a href="warehouse/edit/@warehouse.WarehouseId">
                            <button class="btn btn-primary">Editar</button>
                        </a>                       
                    </td>    
                </tr>                
            }

        </tbody>
    </table>
</div>

@code
{
    private bool DataLoading = false;
    private string loading_message = "Fetching Warehouses from DB ...";

    List<Warehouse> warehouses = new ();
    Warehouse oWarehouse = new ();
    B_Warehouse bWarehouse = null!;

    protected override async Task OnInitializedAsync()
    {
        
        if (DataLoading)
        {
            return;
        }

        try
        {
            DataLoading = true;
            bWarehouse = new(ContextFactory);

            if (bWarehouse is not null)
            {
                warehouses = await bWarehouse.GetWarehouses();
            };

        }
        catch (System.Exception ex)
        {
            throw ex;
        }
        finally
        {
            DataLoading = false;
        }
        
        await base.OnInitializedAsync();
    }
}